#!/usr/bin/perl


###############################################################################
# THIS SOFTWARE IS FREE SOFTWARE! IT IS LICENCED UNDER THE GNU PUBLIC LICENCE
#  (c) Dr. Peter Sebbel alias doc (peter@vdr-portal.de) 
# 
#
#  dvd2vdr (c) 2003-2004 by  Dr. Peter Sebbel, a perl script for the generation of .vdr file as
#  used by the VideoDiskRecorder (VDR) (strip some packets from a DVD stream as provided by tccat
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; version 2 of the License
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.

#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##############################################################################


use strict;
use warnings;

my $IFH;
my @files;
my %outfiles;
my %payload_outfiles;
my $EOF = 0;
my $total_input = 0;
my $dump_packets = 0;
my $frame_has_ts = 0;
my $OFH;

#~ (@files) = @ARGV;
#~ if (scalar(@files) ==0) {
	#~ die "No Files as parameters\n";
#~ }
#~ foreach (@files) {
	#~ print STDERR "Got $_ as input\n";
#~ }

open $OFH, ">./test.vdr" or die "could not open file: $!\n";

process_PES_packets();

sub readNextChunk {
        my $ret_buf = "";
        my $helpbuffer;
        my $bytes_to_read = 10000000;
        while ((length($ret_buf) < 10000000) && (sysread STDIN, $helpbuffer, (10000000 - length($ret_buf)), 0)) {
            $ret_buf .= $helpbuffer;
            $helpbuffer = "";
            #print STDERR "CHUNK: Got til now:" . length($ret_buf) . "\n";
        }
        $total_input += length($ret_buf);
        if (length($ret_buf) < 10000000) {
            print STDERR "\nRead all input, total is $total_input\n";
            $EOF = 1;
        }
        print STDERR "\nRead next chunk, total is $total_input\n";
        my $deb = unpack ("H8", substr($ret_buf,0,4));
        #print STDERR  "CHILD debug: $deb\n";
        return  \$ret_buf;
}
#~ sub readNextChunk{
	#~ if (! $IFH)
		#~ {
		#~ my $firstfile = shift @files;
		#~ print STDERR "trying to open $firstfile\n";
		#~ open $IFH, $firstfile  || die "$! happend while opening $firstfile\n";
		#~ }
	
	#~ my $rbuffer;
	
	#~ my $rbytes = sysread $IFH, $rbuffer, 10000000, 0;

	
	#~ if ($rbytes != 10000000 )
		#~ {
			#~ if (scalar(@files)== 0)
			#~ {
			#~ print STDERR "all Input files processed\n";
			#~ print STDERR "EOF reached\n";
			#~ $EOF = 1;
			#~ }
		#~ else
			#~ {
			#~ my $nextf = shift @files;
			#~ print STDERR "$nextf is the next file\n";
			#~ close $IFH;
			#~ open $IFH, $nextf  || die "$! happend while opening $nextf\n";
			
			#~ my $helpbuffer;
			#~ my $helprbytes = sysread $IFH, $helpbuffer, (10000000 - length($rbuffer)), 0;
			#~ $rbuffer .= $helpbuffer;
			#~ $rbytes += $helprbytes;
			#~ }
		#~ }
 	#~ $total_input += $rbytes;
	#~ my $status = sprintf ("%4d",  ($total_input / 1000000));#/
	#~ print STDERR "$status Mbytes read\n"; #if $self->{debug};  f
	#~ return ($rbuffer);
#~ }



sub process_PES_packets {	
	
	my $offset = 0;  		# stores the position we are at in the current buffer
	my $plength = 0;
	my $lengthcounter = 0;
	my $packetcounter = 0;
	my $loadlength = 0;
	my $packetlength = 0;
	#my $OFH;
	my $head_tmpl = 'H6 H2 n1 B8 B8 C1 B40';
	my $starttime = 0;
	my $gop = "";
	my $PTS_value_bits = "";
	my $PTS_decimal = 0;
	my $lastts= 0;
	
	my $seqstart = pack ("H8", "000001B8");
	my $picstart = pack ("H8", "00000100");
	my %pictypes = (
		"001" =>  "I",
		"010" =>  "P",
		"011" =>  "B",
		);
	
	foreach (keys(%pictypes)){
		print STDERR "Pictype $_ is $pictypes{$_}\n";
	}
	my $GOPstring = "";	
	
	
	my $buffer = ${ readNextChunk() }; 	# First we read the first chunk of data
	
	while ($EOF eq 0 || (($offset + $plength) <= (length($buffer)))) {
		# there are at leat six bytes of header at the beginning of a PES packet
		(my $startcode, my $streamcode, my $plength,
		my $eflags1, my $eflags2, my $header_length, my $PTS_raw_bits)
		= unpack ( $head_tmpl,  substr($buffer, $offset, 14) );
		
		if ($startcode ne "000001") {
			print STDERR "No 0x000001 found at current packet\n$startcode\n"; 
            print STDERR sprintf "Will die at %x and %x\n", ($lengthcounter), $offset;
            print STDERR "$startcode, $streamcode, $plength, $eflags1, $eflags2, $header_length, $PTS_raw_bits \n";
            dump_buffer ($offset, $buffer); 
            exit 1;
        }
        if ((($offset + $plength + 15) > (length($buffer))) && ($EOF == 0)) {
			my $helpbuffer = substr($buffer, $offset);
			$buffer = $helpbuffer . ${ readNextChunk() };
			$offset = 0;
        }
        if ($streamcode eq "ba" ) {
            #print STDERR "ba found, setting plength to 8\n";
            $offset += 14;
            $lengthcounter += 14;
            next;
        }
        if ($streamcode eq "be") {
            #print STDERR "be found: $startcode, $streamcode, $plength,\n";
            $offset += $plength + 6;
            $lengthcounter += $plength + 6;
            next;
            
        }
		

		my $packet = substr($buffer, $offset, ($plength + 6));
		my $payload_start = (9 + $header_length);
		if ($payload_start > length($packet)) {
            print STDERR "Strange, plength is $plength, length of p is " . length($packet) . " and streamcode is $streamcode\n";
        }
        my $payload = substr($packet,$payload_start);
		
		if ($packetcounter == 0) {
			print STDERR "looking for a sequence start...\n";
			if ($payload =~ m/$seqstart/g ){
				print STDERR "found a start\n";
				my $position = pos $payload;
				print STDERR "position = $position\n";
			}
			else {
				print STDERR "matched nothing... \n";
			}
		}
		
		$offset +=  $plength + 6;
        $lengthcounter += $plength + 6;
		$packetcounter++;
		print $packet;
        #print $OFH $packet;
        
		
	}
    close $OFH;
    print STDERR "$packetcounter packets processed, $loadlength and $packetlength\n";
}

sub dump_buffer {
    my $offset = shift;
    my $buffer = shift;
    print STDERR "Dumping buffer from $offset\n";
    while ($offset < (length($buffer))) {
        my $string = unpack("H40",substr($buffer,$offset,20));
        $offset +=40;
        $string =~ s/(\.\.)/ $1 /g;
        print STDERR " $string \n";
        my $dummy = <STDIN>;
    }
}