#!/usr/bin/perl

use strict;
use warnings;
use Tk;

use Fcntl;

my $mw = MainWindow->new;
my $secs = 0;
my $MB = "0 of 0";



my @parameters = @ARGV;
foreach (@parameters) {
    print STDERR "par: $_\n";
}
my $lfile = pop @parameters;

#if (! -d $temp_dir) {
#    die "The last parameter must be a temp dir\n";
#}

my $k = 0;
print "starting with $k\n";
foreach(@parameters) {
    if (-s "$_/index.vdr") {
        $k++;
        print "$_ is ok \n";
    }
}

my $total_recs = $k;
$k = 1;
my $I;
my $pid = fork;
my $start_time = time();
if (! $pid) {
    print "I will run " . (join "\ \n ",@parameters) . "\n";
    exec (@parameters);
}


sysopen(H, "$lfile", O_RDONLY|O_NDELAY) or die "Could not open logfile $lfile: $!\n"; 

$mw->Label(-text => "Summary:   ")->pack();
my $t = $mw->Text(-width => 80, -height => 25, -wrap => 'none')->pack(-expand => 1, -side=> "bottom");
$mw->Label(-text => " sec")->pack(-side => "right");
$mw->Label(-text => "0", -textvariable => \$secs )->pack(-side => "right");
$mw->Label(-text => "0 of 0", -textvariable => \$MB )->pack();


$mw->after(1000, \&update_display, $t);

MainLoop;


sub update_display {

    my($widget) = @_;
    my  $buf;
    $secs = time() - $start_time;
    my $bread = sysread(H, $buf, 10000);
    if ($bread) {
        $widget->insert('end', "$buf\n");
    }
    print STDERR $buf;
    if ($buf =~ /Finished processing/) {
        $widget->insert('end', "Processed recording $k\n");
        $k++;
        if ($k > $total_recs) {
            #print "Finished processing $total_recs recordings in  $secs s.\n";
            $MB = "Please wait for the other programsto finish...\n";
            
        }
    }
    if ($buf =~ /Last fork ended for vdrsync.pl/) {
        $MB = "Finished processing $total_recs recordings in  $secs s.\n";
        $widget->insert('end', "FINISHED.\n");
        $widget->yview('end');
        return;    
    }
    if ($buf =~ /\d+\s+Mbytes of\s+\d+/g) {
        $MB = $& . " read (processing $k of $total_recs)";
    }
    #$widget->insert('end', "Running for $secs secs\n");
    $widget->yview('end');
    $mw->after(1000, \&update_display, $t);
}