#!/usr/bin/perl



###############################################################################
# THIS SOFTWARE IS FREE SOFTWARE! IT IS LICENCED UNDER THE GNU PUBLIC LICENCE
#  (c) Dr. Peter Sebbel alias doc (peter@vdr-portal.de) 
# 
#
#  VDRsync Studio (c) 2003-2004 by  Dr. Peter Sebbel, a perl script supposed to become a GUI for VDRsync,
#  and (a little bit) dvdauthor
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; version 2 of the License
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.

#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##############################################################################



use strict;
use warnings;
use Tk;
use Tk::JPEG::Lite;
use Tk::widgets qw/Balloon ProgressBar/;
use Time::HiRes qw(gettimeofday tv_interval);
use Tk::DirTree;
use Tk::Tree;

require Tk::DialogBox;
require Tk::LabEntry;
require Tk::NoteBook;
require Tk::Dialog;
#require "/home/peter/.vdrsync/VDRRECORDING.pm";


my $next_frameno;
my $recording;
my $current_gop;
my $player_handle;
my $player_pid;
my $play_status = 0;

my $indir = shift or die "No input Dir specified...\n";
my $frameno = shift or 1;
my $cut_flag = shift or 1;





print "VDRplayer: starting with frameno $frameno and cut flag $cut_flag\n";

init ();


my $mw = MainWindow->new;
$mw->title("Hello VDR");
my $play_b = $mw->Button(-text => "Play", -command =>  \&preview_movie)->pack();
my $stop_b = $mw->Button(-text => "Stop", -command =>  sub {exit 0;} )->pack();
my $pause_b = $mw->Button(-text => "Pause", -command => sub {
                        if ($play_status == 0) {
                            $play_status = 1;
                            print "setting status to 1\n";
                            $mw->after(10, \&feed_movie);
                        } else {
                            $play_status = 0;
                            print "setting status to 0\n";
                        }   } )->pack();

$mw->after(100, \&preview_movie);

MainLoop;


sub preview_movie {
	#return;
	if ($player_pid) {
		kill 'TERM', $player_pid;
        close $player_handle;
        $player_pid = 0;
	}
	if (! $indir) {
		return
	}
    
	print "here we should start ffplay\n"; 
	$player_pid = open $player_handle, " | ffplay -";
	$next_frameno = $frameno;
    print "frame to start is  $frameno and  $next_frameno\n";
    print "now returning\n";
    $play_status = 1;
    $mw->after(10, \&feed_movie);
}

sub feed_movie {
    
    #my ($chunk_to_play, $frameno ) = $recording->get_movie_chunk(($next_frameno* 0.04), 1); 
    
    my ($chunk_to_play, $next_frameno) = $recording->get_movie_piece($frameno, undef, $cut_flag); 

	print "Requested chunk from frame $frameno  and got $next_frameno back ";
    $frameno = $next_frameno;
    
    print " and buffer of length " .length($chunk_to_play) . "\n";
  
    if (! $player_pid) {
        print "ooops, child dead?\n"; return;
    }
    if ($play_status == 0) {
        return;
    }
    print $player_handle $chunk_to_play;
    if ($play_status)  {
        $mw->after(10, \&feed_movie);
    } else {
        print "trying to close...\n";
        kill 'TERM', $player_pid;
        close $player_handle;
        print "closed...\n";
    }
}

sub init {
	print "Trying to init\n";
	
    if (! $indir) {
        print "No indir, stopping to init\n";
		return;
	}
    
    print "got $indir as indir\n";
	$frameno = $frameno || 0;
	
    
    $recording = VDRRECORDING->new();
	$recording->init_recording($indir);
	$recording->set_movie_position($frameno);
    print "recording is $recording and frameno is $frameno\n";	
	
}
{######################################################################
######################################################################
######################################################################
######################################################################


package      VDRRECORDING;
require      Exporter;

use strict;
use warnings;


our @ISA       = qw(Exporter);
our @EXPORT    = qw(
		);

our $VERSION   = "0.0.6";		        # Version number


sub new {
	my $invocant = shift;
    my $class   = ref($invocant) || $invocant;
    my $self = {
		files 			  => [],
		file_handles 	  => [],
		file_sizes 		  => [],
		marks_file 		  => "",
        chapter_marks_file=> "",
		summary_file 	  => "",
        movie_size        => 0,
        movie_size_cutted => 0,
        movie_length      => 0,
        movie_length_cutted=> 0,
		index_file 		  => "",
		IFH 			  => "",
		marks 			  => [],
        chapter_marks     => [],
		EOF 			  => 0,
		filepos 		  => 0,
		total_input 	  => 0,
		DIR 			  => "",		      # A dirhandle to the recording's DIR
		total_frames 	  => 0,
		frame_pos 		  => 0,          # Inidicates at which frame the last operation started, usefull for relative Operations
		current_pos 	  => 0,  
		current_frame	  => 0,
		split_output	  => 0,
        cut_info            => {
                start           => 0,
                start_file      => 1,
                start_offset    => 0,
                chunk_length    => 0,
                bytes_written   => 0,
                total_bytes     => 0,
                current_chunk   => "",
                current_offset  => "",
                
                        }, 
        debug               => 0,
        create_index        => "/usr/bin/create_indexvdr.pl",
        debug_log          =>"/tmp/vdrrecording.debug",
		@_,
	};
	return bless $self, $class;
}
sub verify_chapter_marks {
    my $self = shift;
    my @marks = @{ $self->{marks} };
    my @chapter_marks = @{  $self->{chapter_marks} };
    my @new_marks;
    
    $self->VR_dprint("verifying Chapter marks\n");
    
    for (my $i = 0; $i < scalar(@chapter_marks); $i++)  {
        my $cf = $self->mark2frames($chapter_marks[$i]);
        print "checking mark $chapter_marks[$i] at frame $cf \n" if $self->{debug};
        for (my $j = 0; $j < scalar(@marks); $j +=2) {
            my $ok = 0;
            my $f = $self->mark2frames($marks[$j]);
            print "comparing with mark $marks[$j] at frame $f \n" if $self->{debug};
            if ($f <= $cf) {
                print "$f < $cf \n";
                my $ef = $self->mark2frames($marks[$j+1]);
                print "Ok now $ef should be bigger than $cf\n" if $self->{debug};
                if ($ef >= $cf) {
                    print "$ef > $cf \n" if $self->{debug};
                    push @new_marks, $chapter_marks[$i];
                    print "Mark $cf verified...\n" if $self->{debug};
                } 
            } else {
                print "Mark $cf will be removed\n" if $self->{debug};
                last;
            }
        }
    }
    return @new_marks;
}
sub generate_chapters {
   
    my $self = shift;
    my $chapter_interval = shift;
    my $cut = shift || 0;
    
    my @marks = @{ $self->{marks} };
    my @auto_chapters;
    my @frame_marks;
    my $offset = 0;
    my $end = 0;
    my $current_start;
    my $current_end;
    
    
    if (! $cut) {
        for (my $i = 0; $i < $self->{total_frames}; $i += $chapter_interval * 25) {
            push @auto_chapters, $i;             # Also a chapter start at 0...
        }
    } 
    
    else {
    
        for (my $i = 0; $i < scalar(@marks); $i+=2)  {
            my $startf = $self->mark2frames($marks[$i]);
            my $endf;
            if ($marks[$i+1]) {
                $endf = $self->mark2frames($marks[$i+1]);
            } else {
                $endf = $self->{total_frames};
            }
            push @frame_marks, "$startf TO $endf";
            #print "$startf TO $endf\n";
        }
        
        my $counter = 0;
        ($current_start, $current_end) = split / TO /, $frame_marks[$counter];
        $offset = $current_start;
        push @auto_chapters, $offset;           # Always include a chapter start at 0
        #print "starting at $offset to $current_end\n" i;
        while (! $end) {
            if (($offset + $chapter_interval * 25) <= $current_end) {
                $offset += $chapter_interval * 25;
                push @auto_chapters, $offset;
                next;
            } else {
                if (!$frame_marks[$counter+1]) {
                    $end = 1;
                    next;
                }
                my $rest = $current_end - $offset;
                $counter++;
                ($current_start, $current_end) = split / TO /, $frame_marks[$counter];
                $offset = $current_start - $rest;
            }   
        }
    }
    
    foreach(@auto_chapters) {
        my ($real_frame, undef) = $self->find_GOP_offset($_);
        push @{$self->{chapter_marks}}, $self->frames2mark($real_frame);
        $self->VR_dprint("pushed $real_frame as ${$self->{chapter_marks}}[-1]\n") if $self->{debug};
    }
}

sub get_cut_chapter_marks {
    
    my $self = shift;
    
    my @marks = @{ $self->{marks} };
    my @chapter_marks = @{  $self->{chapter_marks} };
    my @new_marks;
    
    
    for (my $i = 0; $i < scalar(@chapter_marks); $i++)  {
        my $cf = $self->mark2frames($chapter_marks[$i]);
        $self->VR_dprint("checking mark $chapter_marks[$i] at frame $cf \n") if $self->{debug};
        my $offset = 0;
        for (my $j = 0; $j < scalar(@marks); $j +=2) {
            my $ok = 0;
            my $f = $self->mark2frames($marks[$j]);
            $self->VR_dprint("Comparing with mark $marks[$j] at frame $f \n") if $self->{debug};
            if ($f <= $cf) {
                $self->VR_dprint("$f < $cf \n") if $self->{debug};
                my $ef = $self->mark2frames($marks[$j+1]);
                $self->VR_dprint("Ok now $ef should be bigger than $cf\n") if $self->{debug};
                if ($ef >= $cf) {
                    $self->VR_dprint("$ef > $cf \n") if $self->{debug};
                    push @new_marks, $offset + $cf - $f;
                    $self->VR_dprint("Mark $cf verified...\n") if $self->{debug};
                    last;
                } 
                $offset += ($ef -$f);
                $self->VR_dprint("offset is now $offset frames\n") if $self->{debug};
                
            } else {
                $self->VR_dprint( "Mark $cf will be removed\n") if $self->{debug};
                last;
            }
        }
    }
    return @new_marks;
}

sub get_cut_marks {
    
    my $self = shift;
    
    my @marks = @{ $self->{marks} };
    
    my @new_marks;
    my $offset = 0;
    
    for (my $j = 0; $j < scalar(@marks); $j +=2) {
        my $f = ($self->mark2frames($marks[$j]));
        $self->VR_dprint("Comparing with mark $marks[$j] at frame $f \n") if $self->{debug};
        my $ef = $self->mark2frames($marks[$j+1]);
        my $chunk_length = $ef - $f;
        push @new_marks, $offset;
        push @new_marks, $offset + $chunk_length - 10;
        $offset += $chunk_length; 
    }
    return @new_marks;
}

sub get_chapter_shots{
 
    my $self   = shift;
    my $subdir = shift;
    my $chapter_length = shift;
    my $help_prog = shift;
    
    my $transcode;
    my $jpeg2yuv;
    
    if ($help_prog =~ /transcode/) {
        $transcode = 1;
    } elsif ($help_prog =~ /jpeg2yuv/) {
        $jpeg2yuv = 1;
    } else {
        die "Need to know which helper program to use...\n";
    }
    
    my @chapter_list;
        
    # First, extract the Video Bits and transform them into JPEGs
    #
    if (! -d "$subdir") {
        mkdir "$subdir" or die "Could not create $subdir: $!\n"; 
    }
    chdir "$subdir/" or die "Could not change to $subdir: $!\n";
    for (my $i = 0; $i < scalar(@{ $self->{chapter_marks} }); $i++) {
        #print "Chunk start mark: ${ $self->{marks} }[$i]\n";
        my $sec = $self->HMS2sec(${ $self->{chapter_marks} }[$i]);
        #print "in sec: $sec\n";
        my $dirname = sprintf("chapter_%04u", $i+1);
        #print "Trying to create $dirname\n";
        if (! -d  "./$dirname") {
            mkdir "./$dirname" or die "Could not create $dirname: $!\n";
        }
        my ($gop, $gopno) = $self->get_gop_at($sec, int($chapter_length * 2.2) +2);
        #print "Got a Video chunk of length " . length($gop) . "\n";
        open FH, ">./$gopno.mpv" or die "can not open file: $!\n";
        binmode FH;
        print FH $gop;
        close FH;
        my ($cmd, $error);
        if ($transcode) {
            $cmd = "transcode -i $gopno.mpv   -z -k -Z 180x144 -F jpg  -x mpeg2,null -o " . $gopno . "_  -y im,null ";
        } elsif ($jpeg2yuv) {
            $cmd = "ffmpeg -i $gopno.mpv -s 150x120 -t $chapter_length ./$dirname/$gopno" . "_%4d.jpg ";
        } else {
            die "You need either transcode or jpeg2yuv for this script to work!\n";
        }
        
        
        $self->VR_dprint("running: $cmd\n");
        $error = system ($cmd . " &> /dev/null");
        
        #unlink "./$gopno.mpv";
        
        if ($error) {
            #cmd_error($cmd);
            $self->VR_dprint("The follwing command returned the error $error\n: $cmd\n");
        }
    }
    chdir ".." or die "Could not change the dir \n";;
    
}

sub read_chunk{
	my $self = shift;
	my ($start, $end) = @_;
	($start, my $fileno) = ( split/ : /, $start );
	$fileno--;
	$end = ( split/ : /, $end )[0];
	my $bytes_to_read = $end - $start;
	my $IFH = ${$self->{file_handles}}[$fileno];
	
	
	my $success = (sysseek $IFH, $start, 0);
	#print "seeked to pos $success, $start\n";
	if (!($start == $success)) {
		die "could not seek, dieing..\n";
	}
	my $rbuffer;
	my $rbytes = sysread $IFH, $rbuffer, $bytes_to_read, 0;

		if ($rbytes != $bytes_to_read) {
            if (! ${$self->{file_handles}}[$fileno+1]) {
                print "Something weird happend, GOP not in files\n";
				exit;
            }
			else {
				$IFH = ${$self->{file_handles}}[$fileno+1];
				
				my $helpbuffer;
				my $helprbytes = sysread $IFH, $helpbuffer, ($bytes_to_read - length($rbuffer)), 0;
				$rbuffer .= $helpbuffer;
				$rbytes += $helprbytes;
			}
		}
	return \$rbuffer;
};

sub find_GOP_offset{
	my $self = shift;
	my $frame = int (shift);
	#print "got frame $frame\n";

    if ($self->binidx2frame($frame)) {
        return ($frame, $self->binidx2frame($frame));
	} 
	my $return_frame = 0;
	my $i = 1;
	while ((! $return_frame) && ($i < 10)) {
        if ($self->binidx2frame($frame - $i))  {
        	#$self->VR_dprint("Frame $i frames before $frame is an I-Frame. Returning " . ($frame - $i) . " " . $self->binidx2frame($frame - $i) . "\n") if $self->{debug};;
		    return ($frame - $i , $self->binidx2frame($frame - $i));
		}
        elsif ($self->binidx2frame($frame + $i)) {
			#$self->VR_dprint(print "Frame $i frames behind $frame is an I-Frame. returning " . ($frame + $i) . " " . $self->binidx2frame($frame + $i) . "\n") if $self->{debug};;
            return ($frame + $i , $self->binidx2frame($frame + $i));
		}
		else {
			#$self->VR_dprint(print "no iframe found in $i frame distance\n"),
			$i++;
		}
	}
	die "could not find a reasonably positioned iframe, exiting\n";
};

sub get_gop_at{
	my $self = shift;
	my $sec_to_get = shift;
    my $gops_to_get = shift || 1;
    (my $current_gop, my $return_frameno) = get_gop($self, $sec_to_get, $gops_to_get);
	return ($current_gop, $return_frameno);
};

sub get_next_gop{
	my $self = shift;
	my $diff = shift;
	if (! $self->{current_frame}) {
		$self->{current_frame} = 1;
	}
	my $now = $self->{current_frame} * 0.04;
	(my $current_gop, $self->{current_frame}) = get_gop($self, $now + $diff, 1);
	return ($current_gop, $self->{current_frame});
};

sub get_file_list {
	my $self = shift;
	my $DIR;
	my $indir = $self->{indir};
	opendir $DIR, $indir or die "Can not open $indir $!\n";
	#print "trying to open $indir\n";
	if (! $DIR) {
		die "did not get a handle back\n";
	}
	my @allfiles =   grep { ! /^\./  } readdir $DIR;
    closedir $DIR;
	my @files =   sort (grep { /\d{3}.vdr$/  } @allfiles);

	$self->{summary_file} = $indir . "summary.vdr" if (-e "$indir/summary.vdr");
	$self->{marks_file} = $indir . "marks.vdr" if (-e "$indir/marks.vdr");
	$self->{index_file} = $indir . "index.vdr" if (-e "$indir/index.vdr");
	$self->{chapter_marks_file} = $indir . "chapter_marks.vdr" if (-e "$indir/chapter_marks.vdr");
    
	foreach (@files) {
		$_ = $indir . $_;
		#print "trying to open $_\n";
		my $DUMMYFH;
		open $DUMMYFH, "$_" or die "Can not open $_: $!\n";
		push @{$self->{file_handles}}, $DUMMYFH;
		my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks)
            = stat $DUMMYFH;
		push @{$self->{file_sizes}},$size;
        $self->{movie_size} += $size;
	}
}

sub read_marks_file {
	my $self = shift;
	if (! $self->{marks_file}) {return;}
	open MFH, "$self->{marks_file}" || die "Could not open marks.vdr";
	@{$self->{marks}} = ();
	my @raw_marks = <MFH>;
	foreach (@raw_marks) {
		chomp $_;
        $_ = (split /\s/, $_)[0];
        if ($_ !~ /^\d{1,2}:\d{1,2}:\d{1,2}\.\d{1,2}$/) {
            $self->VR_dprint("Could not read mark $_, skipping\n");
            next;
        }
		my ($h,$m,$s,$f) = split /[:.]/,$_;
		my $frame = ($h * 3600 + $m * 60 + $s)* 25 + $f;
		my $real_frame = (find_GOP_offset($self, $frame))[0];
		my $real_mark = $self->frames2mark($real_frame);
        if ($real_mark ne "-1") {
            push @{$self->{marks}}, $real_mark;
        }
	}
}


sub read_chapter_marks_file {
	my $self = shift;
	if (! $self->{chapter_marks_file}) {return;}
	#print "Trying to get chapter_marks_file: $self->{chapter_marks_f}\n";
    
	open MFH, "$self->{chapter_marks_file}" or die "Could not open chapter_marks.vdr";
	@{$self->{chapter_marks}} = <MFH>;
	foreach (@{$self->{chapter_marks}}) {
		#print "got chapter_mark $_";
		chomp $_;
		my ($h,$m,$s,$f) = split /[:.]/,$_;
		#print "$h,$m,$s,$f\n";
		my $frame = ($h * 3600 + $m * 60 + $s)* 25 + $f;
		#print "$frame\n";
		my $real_frame = (find_GOP_offset($self, $frame))[0];
		
		$_ = $self->frames2mark($real_frame);
		#print "replaced $frame with $real_frame, result is: $_\n";
	}
}


sub read_index_file{
	my $self = shift;
	
	print "*" x40 ."\n";
	print "READING INDEX FILE, please be patient\n";
	print "*" x40 . "\n";
    
	my $index_file = $self->{index_file};
   	open FH,"$index_file" or die "Can not open File: $!\n";
	binmode FH;
	my $buffer;
	my $bytesread = sysread (FH, $buffer, 10000000);
    $self->{binindex} = $buffer;
	close FH;
    my $offset = 0;
	my $I_counter = 0;
	
  
    my $li_frame = 0;
    $offset = 8;
    while ($li_frame == 0) {
        my ($c, $Ptype, $number, $reserved) = unpack ("I C C S", substr($buffer, (length($buffer) - $offset), 8));
        if ($Ptype == 1) {
            $li_frame = int ((length($buffer) - $offset) / 8);
            print "last Iframe found as frame $li_frame \n";
        } else {
            $offset += 8;
        }
        if ($offset >= (length($buffer)) ) {
            die "Something went horribly wrong\n";
        }
    }
	
	$self->{total_frames} = int(length($self->{binindex}) / 8);
    $self->{last_Iframe} = $li_frame;
	
    return ;
}


sub get_gop {
	my $self = shift;
	my $sec = shift;
	my $gops_to_get = shift || 1;
	if ($sec > $self->{total_frames} * 0.04) {
		$sec = ($self->{total_frames} * 0.04) -1;
	}
	if ($sec < 0) {
		$sec = 0;
	}
	
	my $frame_offset = $sec * 25;
	
	my ($frameno, $gop_offset) = find_GOP_offset($self, $frame_offset);
	$self->VR_dprint("Wanted frame $frame_offset, got $frameno at $gop_offset\n") if $self->{debug};
	
	my $counter = $frameno;
	
    while ($gops_to_get) {
		$counter++;
		if ($counter > $self->{total_frames}) {
            $counter = $self->{last_Iframe};
		}
        if (! $self->binidx2frame($counter)) {
       		next;
		}
		else {
			$gops_to_get--;
		}
	}
	my $gop_end = $self->binidx2frame($counter);
    if ($gop_offset eq $gop_end) {
        my $fileno = (split " : ",$gop_offset)[1];
        $gop_end = ${$self->{file_sizes}}[$fileno - 1] . " : $fileno";
        #print "changed gop end to $gop_end\n";
    }
	$self->VR_dprint("Now we should read the range $gop_offset to $gop_end\n") if $self->{debug};
	
	my $raw_chunk = ${ $self->read_chunk ($gop_offset, $gop_end) };
	my $offset = 0;
	my $video_stream = "";
	my $plength = 0;
	my $packet_counter = 0;
	
	while ($offset + $plength < length($raw_chunk))	{
		# analyse the needed info from PES Header
		my ($startcode,  $streamcode, $plength, $notused, $header_length) = unpack ( "H6 H2 n1 n1 C1", substr($raw_chunk, $offset, 9));
		
		if ($startcode ne "000001") {
			print "No 0x000001 found at current packet, found $startcode and $streamcode instead in packet\n"; exit
		}
		if (! ($streamcode =~/^e/)) {
			#print "video stream $streamcode found\n";
			#print "not a video stream\n";
			$offset +=  $plength + 6;
			next;
		}
		if (($offset + $plength) > (length($raw_chunk))) {
			die "Did not get a rawchunk back that ends with a packet...\n";
			return \$video_stream;
		}
		
		my $packet = substr($raw_chunk, $offset, ($plength + 6));
		my $payload = (substr($packet, 9 + $header_length));
		$offset +=  $plength + 6;
		$video_stream .= $payload; #$packet;#
		$packet_counter++;
	}

	$self->VR_dprint ("returning " . length($video_stream) . " bytes of video data\n");
	$raw_chunk = "";
    
    my %GOP_info;
    my $seqstart = pack("H8", "000001b3");
    
    
    
    if ($video_stream !~ /$seqstart(.{8})/s) {
        print "No luck here...\n";
        print "length is " . (length($video_stream)) ."\n";
    }
    
    my $bitview = unpack("B64", $1);
    my $hor_size = "0b" . substr($bitview,0,12);
    my $horizontal_size = oct $hor_size; 
    
    my $ver_size = "0b" . substr($bitview,12,12);
    my $vertical_size = oct $ver_size;
    
    my $asp_ratio = substr($bitview,24,4);
    my $aspect_ratio;
    if ($asp_ratio eq "0001"){
        $aspect_ratio = "1:1";
    }
    elsif ($asp_ratio eq "0010") {
        $aspect_ratio = "4:3";
    }
    elsif ($asp_ratio eq "0011") {
        $aspect_ratio = "16:9";
    }
    elsif ($asp_ratio eq "0111") {
        $aspect_ratio = "2.21:1";
    }
    else {
        $aspect_ratio = "$asp_ratio";
    }
    
    
    my $fps = substr($bitview,28,4);
    if ($fps eq "0001")    {
        $fps = 23.967;
    }
    elsif ($fps eq "0010")    {
        $fps = 24;
    }
    elsif ($fps eq "0011")    {
        $fps = 25;
    }
    elsif ($fps eq "0100")    {
        $fps = 29.97;
    }
    elsif ($fps eq "0101")    {
        $fps = 30.97;
    }
    my $bitrate_value = 400 * ( oct ("0b" . substr($bitview,32, 18)));
    $self->VR_dprint("Got the following infos:\n\taspect ratio: $aspect_ratio\n\tsize: $horizontal_size" . "x$vertical_size\n");
	return $video_stream, $frameno;
}

sub get_movie_chunk	{
	my $self =shift;
	my $sec = shift;
	
	if ($sec > $self->{total_frames} * 0.04) {
		$sec = ($self->{total_frames} * 0.04) -1;
	}
	if ($sec < 0) {
		$sec = 0;
	}
	my $gops_to_get = shift;
	my $frame_offset = $sec * 25;
	
	my ($frameno, $gop_offset) = find_GOP_offset($self, $frame_offset);
	$self->VR_dprint("IN get_movie_chunk: wanted frame $frame_offset, got $frameno at $gop_offset\n") if $self->{debug};
	
	my $counter = $frameno;
	while ($gops_to_get) {
		$counter++;
		if ($counter > $self->{total_frames}) {
			$counter = $self->{last_Iframe};
		}
		if (! $self->binidx2frame($counter)) {
			next;
		}
		else {
			$gops_to_get--;
		}
	}
	my $gop_end = $self->binidx2frame($counter);
	$self->VR_dprint("Now we should read the range $gop_offset to $gop_end\n") if $self->{debug};
	
	my $raw_chunk = ${ $self->read_chunk($gop_offset, $gop_end) };
	my $offset = 0;
	my $video_stream = "";
	my $plength = 0;
	my $packet_counter = 0;
	
	while ($offset + $plength < length($raw_chunk))	{
		# analyse the needed info from PES Header
		my ($startcode,  $streamcode, $plength, $notused, $header_length) = unpack ( "H6 H2 n1 n1 C1", substr($raw_chunk, $offset, 9));
		
		if ($startcode ne "000001") {
			print "No 0x000001 found at current packet, found $startcode and $streamcode instead in packet\n"; exit
		}
		if (($streamcode =~/^b/)) {
			#print "video stream $streamcode found\n";
			#print "not a video stream\n";
			$offset +=  $plength + 6;
			next;
		}
		if (($offset + $plength) > (length($raw_chunk))) {
			die "Did not get a rawchunk back that ends with a packet...\n";
			return \$video_stream;
		}
		
		my $packet = substr($raw_chunk, $offset, ($plength + 6));
		my $payload = (substr($packet, 9 + $header_length));
		$offset +=  $plength + 6;
		$video_stream .= $payload;
		$packet_counter++;
	}

	print "returning " . length($video_stream) . " bytes of vdr data\n";
	#return $video_stream, $frameno;
    return $raw_chunk, $frameno;
}

sub cut_movie {
    my $self = shift;
    my $out_dir = shift || "./";
    my $split = shift || 0;
    my $mainw = shift || 0;
    my $prog_ind = shift || 0;   
    my $file_size = shift || 2000000000;
   
    my $stepsize = 0;
    
    
    $self->compute_movie_cuts();
    if ($mainw && $prog_ind && $self->{movie_size_cutted}) {
        $stepsize = 100 / ($self->{movie_size_cutted} / 10000000);
        #print "$mainw and $prog_ind and $stepsize and $self->{movie_size_cutted}\n";
    }
  
	
    my @chunks = @{$self->{cut_chunks}};
	print "in do_cut we got @chunks and $self->{split_output} for split\n";
	
    my $start;
	my $total_bytes    = 0;
	    
    my $cunk_no = scalar(@chunks);
    my $start_file;
    my $end_file;
    my $start_offset;
    my $end_offset;
	my $buffer;
    my $rbuffer;
    my $offset = 0;
    my $EOF = 0;
    my $current_chunk = 0;
    my $current_file = 0;
    my $bytes_written = 0;
    
    
    
    ($start_offset, $start_file, $end_offset, $end_file) = split/ : | TO /, $chunks[$current_chunk];


    $current_file   = $start_file;
    $offset = $start_offset;
    
    my $IFH = ${$self->{file_handles}}[$start_file - 1];
    
    my $success = (sysseek $IFH, $start_offset, 0);
    print "seek to $success in $start_file\n";
	
	if (! $success) {
		print "could not seek, dieing..\n"; die;
	}
    print "opening | $self->{create_index}  -s $file_size -o \"$out_dir\"\n";
    open OFH, "| $self->{create_index}  -s $file_size -o \"$out_dir\"" or die "Could not open output file\n";
    binmode OFH;
    select((select(OFH), $| = 1)[0]);
    while (! $EOF) {
        my $bytes_to_read = 10000000;
        while ($bytes_to_read ) {
            print "we are now at: " . (sysseek($IFH, 0, 1)) ." in file $IFH\n";
            print "Current Chunk : $chunks[$current_chunk] \n";
            if ($current_file == $end_file) {
                if (($end_offset - $offset ) > 10000000) {
                    print "Enough bytes to read left in this file for $bytes_to_read \n";
                    my $rbytes = sysread $IFH, $rbuffer, $bytes_to_read, 0;
                    print "Read $rbytes\n";
                    if ($rbytes == 0) {
                        die "Holy shit, start_offset is $start_offset, offset is $offset, end_offset is $end_offset, diff is " . ($end_offset - $offset) ." and we are at the end of the file...?\n";
                    }
                    $bytes_to_read  -= $rbytes;
                    $buffer         .= $rbuffer;
                    $offset += $rbytes;
                    print "EE offset is now $offset, end_offset is $end_offset, diff is " . ($end_offset - $offset) ."\n";
                    #print "bytes_to_read is now $bytes_to_read\n";
                }
                else {
                    print "not enough bytes to read left in current chunk or this was the last chunk\n";
                    print "Trying to read " . ($end_offset - $offset) ."\n";
                    my $rbytes = sysread $IFH, $rbuffer, ($end_offset - $offset), 0;
                    $bytes_to_read  -= $rbytes;
                    $offset += $rbytes;
                    $buffer         .= $rbuffer;
                   
                    if ($chunks[$current_chunk + 1]) {
                        # Here we go for additional Audio at the end of a chunk
                        # So we try to red the Audio from the next GOP, and append it to the current buffer.
                        # Thereby we should always have enough Audio in the buffer, and can prevent the
                        # insertion of Silent frames
                        #
                    
                        #my $add_audio = get_audio_from_gop($self);
                    
                        #print "length before " . length($buffer) . "\n" if $self->{debug};
                        #$buffer      .= $add_audio if $add_audio;
                        #$buffer      .= $add_audio if $add_audio;
                        #print "length after " . length($buffer) . "\n" if $self->{debug};
                        #
                        #
                        $current_chunk++;
                        ($start_offset, $start_file, $end_offset, $end_file) = split/ : | TO /, $chunks[$current_chunk];
                        $current_file   = $start_file;
                        $offset = $start_offset;
                        $IFH = ${$self->{file_handles}}[$start_file - 1];
                        #print "$IFH\n";
                        $success = (sysseek $IFH, $start_offset, 0);
                        print "After Switch: $start_file}, $offset}, $end_file, $end_offset\n";
                    } else {
                        print "This was the last chunk!\n";
                        $bytes_to_read = 0;
                        $EOF = 1;
                    }
                }
            }
            else { 
                my $rbytes = sysread $IFH, $rbuffer, $bytes_to_read, 0;
                $bytes_to_read  -= $rbytes;
                $offset += $rbytes;
                $buffer .= $rbuffer;
                
                print "NE offset is now $offset, end_offset is $end_offset, diff is " . ($end_offset - $offset) ." in file $current_file\n";
                if ($bytes_to_read) {
                    print "That was not enough in this file, switching to next file $current_file\n";
                    $IFH = ${$self->{file_handles}}[$current_file];
                    $current_file++;
                    #print "$IFH\n";
                    $success = (sysseek $IFH, 0, 0);
                    $offset = 0;
                    #print "After Switch: $start_file, $start_offset, $end_file, $end_offset\n";
                } 
            }
            
            $bytes_written += length($buffer);
            
            print "in VDRrecording read $bytes_written until now\n";
            if ($mainw && $prog_ind) {
                $$prog_ind += $stepsize;
                print "$prog_ind is now prog $stepsize\n";
                $mainw->update; 
            }
           #print TOF $buffer;
            print OFH $buffer;
            
            $buffer = "";
        }
    }
    close OFH;
    my @new_chap_marks =  $self->get_cut_chapter_marks();
    open OFH, ">$out_dir/chapter_marks.vdr" or die "Could not open chapter_marks.vdr: $!\n";
    foreach (@new_chap_marks) {
        print OFH ($self->frames2mark($_) . "\n");
    }
    close OFH;
    my @new_marks =  $self->get_cut_marks();
    open OFH, ">$out_dir/marks.vdr" or die "Could not open marks.vdr: $!\n";
    foreach (@new_marks) {
        print OFH ($self->frames2mark($_) . "\n");
    }
    close OFH;
}
    
    



sub get_movie_piecewise {
	my $self = shift;
    my $bytes_to_read = shift || 10000000;
	
    my @chunks = @{$self->{cut_chunks}};
	#print "in do_cut we got @chunks and $self->{split_output} for split\n";
	
    my $start;
	my $total_bytes    = 0;
	    
    my $cunk_no = scalar(@chunks);
    
        	
    my $start_file;
    my $end_file;
    my $start_offset;
    my $end_offset;
	my $buffer;
    my $rbuffer;
    
    if (! $self->{bytes_written}) {
       # foreach (@chunks) {
       #     print "Processing $_\n";
       #     my ($start, $end) = split/ TO /, $_;
       #     print "do_cut: $start, $end\n";
        #}
    }
    
    
    if ($self->{EOF}) {
        return "";
    }

    #print "next round of reading\n";
    ($start_offset, $start_file, $end_offset, $end_file) = split/ : | TO /, $chunks[$self->{current_chunk}];

    if ((! $self->{current_chunk}) && (! $self->{bytes_written})) {
        #print "seems to be the very first read...\n";
        $self->{current_file}   = $start_file;
        $self->{current_offset} = $start_offset;
    }
        #print " Now we move to $self->{current_file}, $self->{current_offset}, $end_file, $end_offset\n";
        
        
	my $IFH = ${$self->{file_handles}}[$self->{current_file} - 1];
    #print "$IFH\n";
    my $success = (sysseek $IFH, $self->{current_offset}, 0);
	#print "seeked to pos $success, $start\n";
	if (!($self->{current_offset} == $success)) {
		print "could not seek, dieing..\n"; die;
	}
    
    while ($bytes_to_read && (! $self->{EOF})) {
        if ($self->{current_file} == $end_file) {
            #print "start file is end file: $self->{current_file}, $self->{current_offset}, $end_file, $end_offset\n";
            if (($end_offset - $self->{current_offset}) > $bytes_to_read) {
                #print "Enough bytes to read left in this file\n";
                my $rbytes = sysread $IFH, $rbuffer, $bytes_to_read, 0;
                #print "Read $rbytes\n";
                $bytes_to_read  -= $rbytes;
                $buffer         .= $rbuffer;
                $self->{current_offset} += $rbytes;
                #print "current offset is now $self->{current_offset}\n";
                #print "bytes_to_read is now $bytes_to_read\n";
            }
            else {
                #print "not enough bytes to read left in current file or end of recording\n";
                #print "Trying to read " . ($end_offset - $self->{current_offset}) ."\n";
                my $rbytes = sysread $IFH, $rbuffer, ($end_offset - $self->{current_offset}), 0;
                $bytes_to_read  -= $rbytes;
                $self->{current_offset} += $rbytes;
                $buffer         .= $rbuffer;
                if ($chunks[$self->{current_chunk} + 1]) {
                    # Here we go for additional Audio at the end of a chunk
                    # So we try to red the Audio from the next GOP, and append it to the current buffer.
                    # Thereby we should always have enough Audio in the buffer, and can prevent the
                    # insertion of Silent frames
                    #
                    
                    my $add_audio = get_audio_from_gop($self);
                    print "length before " . length($buffer) . "\n" if $self->{debug};
                    $buffer      .= $add_audio if $add_audio;
                    $buffer      .= $add_audio if $add_audio;
                    print "length after " . length($buffer) . "\n" if $self->{debug};
                    #
                    #
                    $self->{current_chunk}++;
                    ($start_offset, $start_file, $end_offset, $end_file) = split/ : | TO /, $chunks[$self->{current_chunk}];
                    $self->{current_file}   = $start_file;
                    $self->{current_offset} = $start_offset;
                    $IFH = ${$self->{file_handles}}[$start_file - 1];
                    #print "$IFH\n";
                    $success = (sysseek $IFH, $self->{current_offset}, 0);
                    #print "After Switch: $self->{current_file}, $self->{current_offset}, $end_file, $end_offset\n";
                } else {
                    $self->{EOF} = 1;
                }
            }
        }
        else { 
            my $rbytes = sysread $IFH, $rbuffer, $bytes_to_read, 0;
            $bytes_to_read  -= $rbytes;
            $self->{current_offset} += $rbytes;
            $buffer         .= $rbuffer;
            #print "in the current file could read " . length($buffer) . " bytes\n";
            if ($bytes_to_read) {
                #print "That was not enough, switching to next file\n";
                $IFH = ${$self->{file_handles}}[$self->{current_file}];
                $self->{current_file}++;
                #print "$IFH\n";
                $success = (sysseek $IFH, 0, 0);
                $self->{current_offset} = 0;
                #print "After Switch: $start_file, $start_offset, $end_file, $end_offset\n";
            } 
        }
            
    }
    
    if ($self->{EOF}) {
        # Here we go for additional Audio at the end of a chunk
        # So we try to red the Audio from the next GOP, and append it to the current buffer.
        # Thereby we should always have enough Audio in the buffer, and can prevent the
        # insertion of Silent frames
        #
        my $add_audio = get_audio_from_gop($self);
        $buffer .= $add_audio if $add_audio;
    }


    #print "in VDRrecording read " . length($buffer) . " until now\n";
    $self->{bytes_written} += length($buffer);
    #print TOF $buffer;
    return $buffer;
    #close TOF;
    #die "finished all?\n";
}

sub find_target_frame {
    my $self = shift;
    my $start_frame    = shift || 1; 
    my $add_frames = shift || 100;
    my @frame_marks;
    my @frame_chunks;
    
    for (my $i = 0; $i < scalar(@{$self->{marks}}); $i += 2) {
        push @frame_marks, $self->mark2frames(${$self->{marks}}[$i]);
        if ($self->mark2frames(${$self->{marks}}[$i + 1])) {
            push @frame_marks, $self->mark2frames(${$self->{marks}}[$i + 1]);
            push @frame_chunks, $self->mark2frames(${$self->{marks}}[$i]) . " TO " . $self->mark2frames(${$self->{marks}}[$i+1]);
        }
    }
    
}

sub get_movie_piece {
	
    my $self = shift;
    my $start_frame = shift || 1;         # What is the start point (in Frames)?
    my $frames_to_read = shift || 96;     # How man Frames should be read?
    my $cut_flag    = shift || 0;         # Should the cut marks be observed?
    #my $add_audio   = shift || 0;        # Should the routine add Audio at cutting points?
    #my $ret_format  = shift || "PES";    # For the moment ignored, in the future it should be used to provide PES or ES or Audio Only and things like that

    print "got params: self $self startf $start_frame, frames_to_read: $frames_to_read cut_flag $cut_flag\n";
    
    my $cur_chunk   = 0;
	my $end_frame;
    
    
    my @frame_chunks;
    my @read_chunks;
    
    for (my $i = 0; $i < scalar(@{$self->{marks}}); $i += 2) {
        if ($self->mark2frames(${$self->{marks}}[$i + 1])) {
            push @frame_chunks, $self->mark2frames(${$self->{marks}}[$i]) . " TO " . $self->mark2frames(${$self->{marks}}[$i + 1]);
        }
    }
    
    ($start_frame, my $byte_start) = $self->find_GOP_offset($start_frame);


    # Calculate whether the start frame is within a selected region
	if ($cut_flag && (scalar(@frame_chunks > 0))) {
        print "movie has marks and should be cut    \n";
        my $hit = 0;
        my ($chunk_s, $chunk_e);
        while (! $hit) {
            ($chunk_s, $chunk_e) = split / TO /, $frame_chunks[$cur_chunk];
            if ($chunk_e < $start_frame) {
                if ($frame_chunks[$cur_chunk + 1]) {
                    $cur_chunk += 1;
                    next;
                } else {
                    return undef;
                }
            } else {
                if ($start_frame >= $chunk_s) {
                    $hit = 1; 
                } else {
                    
                    $start_frame = $chunk_s;
                    $hit = 1;
                    print "start frame was out of movie region, correcting to $start_frame\n";
                }
            }
        }
        
        my $i = $start_frame;
        my $j = $frames_to_read;
        my $k = $cur_chunk;
        
        push @read_chunks, $self->binidx2frame($start_frame);
        print "START serach for endframe\n";
        while ($j) {
            if ($chunk_e < $i + $j) {
                print "not enough frames in current chunk left\n";
                $j -= ($chunk_e - $i);
                print "need $j frames in addition\n";
                push @read_chunks, $self->binidx2frame($chunk_e);
                $k++;
                print "switching to next chunk $k\n";
                ($chunk_s, $chunk_e) = split / TO /, $frame_chunks[$k];
                push @read_chunks, $self->binidx2frame($chunk_s);
                print "Added chunk start tor rewad list $chunk_s\n";
                $i = $chunk_s;
            } else {
                print "Enough frames in this chunk left...\n";
                $end_frame = $i + $j;
                $j = 0;
                ($end_frame, undef) = $self->find_GOP_offset($end_frame);
                push @read_chunks, $self->binidx2frame($end_frame);
            }
        }
        print "END serach for endframe\n";
    } else { # No Cut Flag!!!
        ($end_frame, undef) = $self->find_GOP_offset($start_frame + $frames_to_read);
        push @read_chunks, $self->binidx2frame($start_frame);
        push @read_chunks, $self->binidx2frame($end_frame);
    }
    print "\ngoing to show the movie from frame $start_frame to $end_frame, and that is in chunk $cur_chunk\n";
    
    print "\n" . (join " DADA ",@read_chunks) . "\n";
    
    my $buffer;
    my $rbuffer;
    my $hbuffer;
    
    
    for (my $i = 0; $i < scalar(@read_chunks); $i += 2) {
        my ($soff, $sfile) = split / : /, $read_chunks[$i];
        my ($eoff, $efile) = split / : /, $read_chunks[$i + 1];
        my $IFH = ${$self->{file_handles}}[$sfile  - 1];
        
        
        
        my $success = (sysseek $IFH, $soff, 0);
        if (!($soff == $success)) {
            die "could not seek, dieing..\n";
        }
        while ($sfile < $efile) {
            my $bytes_to_read = ${$self->{file_sizes}}[$sfile - 1] - $soff;
            my $rbytes = sysread $IFH, $hbuffer, $bytes_to_read, 0;
            $rbuffer .= $hbuffer;
            $sfile++;
            $soff = 0;
        }
        
        my $rbytes = sysread $IFH, $hbuffer, ($eoff - $soff), 0;
        $rbuffer .= $hbuffer;
    }

    print "retunrning a buffer of length " . length($rbuffer) . " and frame number  $end_frame\n";

    return ($rbuffer, $end_frame);
    
    
    
}


sub get_audio_from_gop {
    my $self = shift;
    print "current chunk is $self->{current_chunk}\n" if $self->{debug};
    print "In marks that means ${$self->{marks}}[$self->{current_chunk}*2] and ${$self->{marks}}[$self->{current_chunk}*2+1]\n" if $self->{debug};;
    print "$self->{bytes_written} bytes written for ${$self->{cut_chunks}}[$self->{current_chunk}]\n"if $self->{debug};;
    
    my $search_frame = mark2frames($self, ${$self->{marks}}[$self->{current_chunk}*2+1]);
    
    #Check whether the next chunk is just behind, then we skip additional Audio
    if (${$self->{marks}}[$self->{current_chunk} * 2 + 2]) {
        my $next_frame = mark2frames($self, ${$self->{marks}}[$self->{current_chunk}*2 + 2]);
        if (($next_frame - $search_frame) < 36) {
            return;
        }
    }
 
    print "searching for additional GOP starting at $search_frame\n" if $self->{debug};
    my $counter = 0;
 
    if (! $self->binidx2frame($search_frame)) {
        print "did not find additional GOP at end of this chunk\n";
        return;
    }
    
    my ($frameno, $gop_offset) = find_GOP_offset($self, $search_frame);
	print "wanted frame $search_frame, got $frameno at $gop_offset\n" if $self->{debug};
	
	    
    $self->VR_dprint("Next GOP should start at frame $search_frame\n") if $self->{debug};
       
    my $gops_to_get = 2;
    
    $counter = $search_frame;
	
    while ($gops_to_get) {
		$counter++;
		if ($counter > $self->{total_frames}) {
			$counter = $self->{last_Iframe};
		}
		if (! $self->binidx2frame($counter)) {
			next;
		}
		else {
			$gops_to_get--;
		}
	}
	my $gop_end = $self->binidx2frame($counter);
	
    print "Now we should read the range $gop_offset to $gop_end\n" if $self->{debug};
	
	my $raw_chunk = ${ read_chunk ($self, $gop_offset, $gop_end) };
	my $offset = 0;
	my $audio_buffer = "";
	my $plength = 0;
	my $packet_counter = 0;
	
	while ($offset + $plength < length($raw_chunk))	{
		# analyse the needed info from PES Header
		my ($startcode,  $streamcode, $plength, $notused, $header_length) = unpack ( "H6 H2 n1 n1 C1", substr($raw_chunk, $offset, 9));
		
		if ($startcode ne "000001") {
			print "No 0x000001 found at current packet, found $startcode and $streamcode instead in packet\n"; exit
		}
		if ($streamcode =~/^e/) {
			#print "video stream $streamcode found\n";
			$offset +=  $plength + 6;
			next;
		}
		if (($offset + $plength) > (length($raw_chunk))) {
			die "Did not get a rawchunk back that ends with a packet...\n";
			return \$audio_buffer;
		}
		
		my $packet = substr($raw_chunk, $offset, ($plength + 6));
		my $payload = (substr($packet, 9 + $header_length));
		$offset +=  $plength + 6;
		#print "adding a packet for stream $streamcode\n";
        $audio_buffer .= $packet;
        $packet_counter++;
	}

	print "returning " . length($audio_buffer) . " bytes of audio packet data\n" if $self->{debug};
	return $audio_buffer;
}

sub set_movie_position {
    my $self = shift;
    my $frameno = shift || 1;
    my $return_no = 1;
    my $chunk_no  = 1;
    my @marks = @{$self->{marks}};
    if (! @marks) {
        push @marks,"0:00:00.1";
    }
    
    if ($frameno < $self->mark2frames($marks[0])) {
        $return_no =  $self->mark2frames($marks[0]);
    }
    if ($frameno > $self->mark2frames($marks[-1])) {
        $return_no = $self->mark2frames($marks[0]);
    }
        
    for (my $j = 0; $j < scalar(@marks); $j +=2) {
        my $ok = 0;
        my $sf = $self->mark2frames($marks[$j]);
        print "comparing with mark $marks[$j] at frame $sf \n";
        if ($sf <= $frameno) {
            my $ef = $self->mark2frames($marks[$j+1]);
            if ($ef >= $frameno) {
                $return_no = $frameno;
                $chunk_no = ($j + 2) / 2;
            }
        } 
    }
    
    ($return_no, my $gop_offset) = $self->find_GOP_offset($return_no);
    my ($offset, $current_file) =  split( / : /,$gop_offset);
    $self->{current_chunk}  = $chunk_no - 1;
    $self->{current_file}   = $current_file;
    $self->{current_offset} = $offset;
}


sub compute_movie_cuts {
	my $self = shift;
	
	my @chunks;
   	my @marks                  = @{$self->{marks}};
	my @file_sizes             = @{$self->{file_sizes}};
    my $total_frames_cutted    = 0;
    $self->{movie_size_cutted} = 0;
    
    
    
    if (scalar(@marks) < 2) {
        print "no cutting without marks...\n";
        return -1;
    }
    
    # Here we check whether the marks are just remains from an already cutted movie
    # Criteria: First and last I-Frame are marked, and the diff between the marks inside are smaller than 20
    
    my $is_cutted = 1;
    if (($marks[0] eq "0:00:00.01") && (mark2frames($self, $marks[-1]) == $self->{last_Iframe})) {
        for (my $i = 1; $i < scalar(@marks) - 2; $i += 2) {
            if ((mark2frames($self,$marks[$i+1]) - mark2frames($self,$marks[$i])) < 20) {
                next;
            } else {
                $is_cutted = 0; 
                last;
            }
        }
    } else {
        $is_cutted = 0;
    }    
    
    if ($is_cutted) {
        print "CAUTION: You specified the -cut Option, but the marks look like remains of an already cutted movie!\nI will process the full movie!\n";
        my $startframe = mark2frames($self, $marks[0]);
        my $startpos   = $self->binidx2frame($startframe);
        my $endframe   = mark2frames($self, $marks[-1]);
        my $endpos     = $self->binidx2frame($endframe);
        if ((! $startpos) || (! $endpos)) {
            print "Mark does not mark an Iframe, cutting stopped!\n";
            return -1;
        }
        $total_frames_cutted += $endframe - $startframe;
        push @chunks, "$startpos TO $endpos";
    } else {
        for (my $i = 0; $i < (scalar(@marks)); $i += 2) {
            if ($marks[$i+1]) {
                my $startframe = mark2frames($self, $marks[$i]);
                my $startpos   = $self->binidx2frame($startframe);
                my $endframe   = mark2frames($self, $marks[$i + 1]);
                my $endpos     = $self->binidx2frame($endframe);
                if ((! $startpos) || (! $endpos)) {
                    print "Mark does not mark an Iframe, cutting stopped!\n";
                    return -1;
                }
                $total_frames_cutted += $endframe - $startframe;
                push @chunks, "$startpos TO $endpos";
               }
        }
    }
		
	@{$self->{cut_chunks}} = @chunks;
	foreach (@chunks) {
		my ($start_offset, $start_file, $end_offset, $end_file) = split/ : | TO /, $_;
        if ($start_file == $end_file) {
            $self->{movie_size_cutted} += $end_offset - $start_offset;
        } else {
            while ($start_file < $end_file) {
                $self->{movie_size_cutted} += $self->{file_sizes}[$start_file -1] - $start_offset;
                $start_offset = 0;
                $start_file++;
            }
            
            $self->{movie_size_cutted} += $end_offset;
            
        }
	}
    $self->{movie_length_cutted} = HMS2sec($self, frames2mark($self, $total_frames_cutted));
    
}


sub frames2mark {
	my $self = shift;
	my $now = shift;
	if (! $now) {
		$now = $self->{current_frame};
	}
	my $rest = $now  % 25;
	my $full_secs = int ($now  * 0.04);
	
	my $h = int($full_secs/3600);
	my $min = int(($full_secs - (3600 * $h)) / 60);
	my $sec = $full_secs - (3600 * $h + 60 * $min);
	return sprintf "%1u:%02u:%02u.%02u", $h, $min, $sec, $rest;
}

sub mark2frames{
	my $self = shift;
	my $mark = shift;
    if (! $mark) {return undef};
	my($h, $m, $s, $f) = split /[:.]/, $mark;
	my $frame = (3600 * $h + 60 * $m + $s) * 25 + $f ;
	return $frame;
}


sub init_recording {
	my $self = shift;
	my $indir = shift;
	if (! $indir) {
		print "Did not receive a dir!\n";
		return;
	}
	$self->{indir} = $indir;
	foreach (@{$self->{file_handles}}) {close $_};
	@{$self->{file_handles}} = ();
	@{$self->{files}} = ();
	@{$self->{marks}} = ();
	@{$self->{file_sizes}} = ();
	@{$self->{cut_chunks}} = ();
	$self->{total_input} = 0;
	$self->{EOF} = 0;
	$self->{filepos} = 0;
	$self->{total_frames} = 0;
	$self->{current_chunk} = 0;
	$self->{bytes_read_for_chunk} = 0;
	$self->{binindex} = 0;
	
	# check the files in the Dir 
	get_file_list($self);
	# THIS SCRIPT NEEDS A VALID index.vdr
	read_index_file($self);
	# If an exisiting marks file is found, it is read
	read_marks_file($self);
    # If an exisiting chapter_marks file is found, it is read
	read_chapter_marks_file($self);

	
    $self->{frameno} = 1;
	$self->{movie_length} = frames2mark($self, $self->{total_frames});

	$self->{current_pos} = frames2mark($self, $self->{frame_pos});
	$self->{mark_no} = scalar(@{$self->{marks}});
    $self->compute_movie_cuts;
}
sub HMS2sec {
    my $self = shift;
    my $HMS = shift;
      
    my ($h, $m, $s, $f) = split /:|\./, $HMS;
    return ($h * 3600 + $m * 60 + $s + $f * 0.04);
}

sub VR_dprint {
    my $self = shift;
   # print "IN VR_dprint \n";
    
    if ((! $self->{debug}) || (! $self->{debug_log})) {
        return
    }
    my $msg = shift;
    print "$msg";
    open DFH, ">>$self->{debug_log}" or die "Can not open debug.log: $!\n";
    binmode DFH;
    print "VDRRECORDING: $msg";
    print DFH "VDRRECORDING: $msg";
    close DFH;
}

sub frames2HMS {
    my $self = shift;
    my $frames = shift;
    
    my $total_sec = int($frames * 0.04 + 0.5);
    
    my ($h, $m, $s);

    $h = int ($total_sec / 3600);
    $m = int(($total_sec - $h *3600) / 60);
    $s = int($total_sec - $h *3600 - $m * 60);
    
    return sprintf("%02u:%02u:%02u", $h, $m, $s);
}

sub binidx2frame {
    my $self = shift;
    my $frame = int (shift );
    
   
    #print "bindex has a length of " . length($self->{binindex}) .",searching for frame $frame\n";
    if ($frame > $self->{last_Iframe}) {
        print "Got only $self->{total_frames}, you wanted $frame and last IFrame is $self->{last_Iframe}...\n";
        $frame = $self->{last_Iframe};
    }
    my $offset = 8 * $frame;
    #print "going to show frame $frame of $self->{total_frames} at offset $offset\n";
    my ($c, $Ptype, $number, $reserved) = unpack ("I C C S", substr($self->{binindex}, $offset, 8));
		#print "Got $c, $Ptype, $number, $reserved\n";
    if ($Ptype == 1) {
        $self->VR_dprint("returning $c : $number\n") if $self->{debug};
        return "$c : $number" ;
    } else {
        #print "NOTHING FOUND; RETURNING UNDEF\n";
        return undef;
    }
} 
}